<?php

?>
<?php

/**
 * Builds a table of un-used or duplicate images
 */
class CloudCoders_NetSuite_Block_Adminhtml_Cleanup_Grid extends Mage_Adminhtml_Block_Widget_Grid
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('cleanupGrid');
        $this->setDefaultSort('cleanup_id');
        $this->setDefaultDir('ASC');
        $this->setFilterVisibility(false);
        $this->setHeadersVisibility(false);
        $this->setSaveParametersInSession(true);
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('netsuite/cleanup')->getCollection();
        $this->setCollection($collection);

        return parent::_prepareCollection();
    }

    protected function _prepareColumns()
    {

        $this->addColumn('filename', array(
            'header' => Mage::helper('netsuite/cleanup')->__('Image'),
            'renderer' => 'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Image',
            'align' => 'left',
            'index' => 'filename'
        ));

        $this->addColumn('action', array(
            'header' => Mage::helper('netsuite/cleanup')->__('Action'),
            'width' => '100',
            'type' => 'action',
            'getter' => 'getId',
            'actions' => array(
                array(
                    'caption' => Mage::helper('netsuite/cleanup')->__('delete'),
                    'url' => array('base' => '*/*/delete'), // get the current controller delete action url
                    'field' => 'id'
                )
            ),
            'filter' => false,
            'sortable' => false,
            'index' => 'stores',
            'is_system' => true,
        ));

        return parent::_prepareColumns();
    }

    protected function _prepareMassaction()
    {

        $this->setMassactionIdField('cleanup_id');
        $this->getMassactionBlock()->setFormFieldName('cleanup');

        $this->getMassactionBlock()->addItem('delete', array(
            'label' => Mage::helper('netsuite/cleanup')->__('Delete'),
            'url' => $this->getUrl('*/*/massDelete'), // get the current controller mass delete action url
            'confirm' => Mage::helper('netsuite/cleanup')->__('Are you sure?')
        ));
        return $this;
    }

}