<?php

?>
<?php

/**
 * History model administrator backend form
 *
 * This Class generates the backend form use to
 * view log history.
 */
class CloudCoders_NetSuite_Block_Adminhtml_History_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{

    /**
     * Adds the form fields
     *
     * @return Form Magento form object
     */
    protected function _prepareForm()
    {

        $form = new Varien_Data_Form();
        $this->setForm($form);
        $fieldset = $form->addFieldset('sync_history_form', array('legend' => Mage::helper('netsuite')->__('History Information')));

        $fieldset->addField('sync_message', 'textarea', array(
            'label' => Mage::helper('netsuite')->__('Message'),
            'name' => 'sync_message',
            'readonly' => true,
            'style' => 'width: 800px;',
            'disabled' => true,
        ));

        $fieldset->addField('sync_data', 'textarea', array(
            'label' => Mage::helper('netsuite')->__('Data'),
            'name' => 'sync_data',
            'readonly' => true,
            'style' => 'width: 800px;',
            'disabled' => true,
        ));

        if (Mage::getSingleton('adminhtml/session')->getSyncHistoryrData()) {
            $form->setValues(Mage::getSingleton('adminhtml/session')->getSyncHistoryData());
            Mage::getSingleton('adminhtml/session')->setSyncHistoryData(null);
        } elseif (Mage::registry('sync_history')) {
            $form->setValues(Mage::registry('sync_history')->getData());
        }
        return parent::_prepareForm();
    }

}