<?php

?>
<?php

/**
 * Builds the history table view
 */
class CloudCoders_NetSuite_Block_Adminhtml_History_Grid extends Mage_Adminhtml_Block_Widget_Grid
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('historyGrid');
        $this->setDefaultSort('history_id');
        $this->setDefaultDir('DESC');
        $this->setEmptyText('No Sync History');
        $this->setSaveParametersInSession(true);
        $this->setVarNameFilter('history_filter');
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('netsuite/history')->getCollection();
        $this->setCollection($collection);

        return parent::_prepareCollection();
    }

    protected function _prepareColumns()
    {
        $evenWidthCell = '60px'; // Magento will try to distribute the cells evenly

        $this->addColumn('history_id', array(
            'header' => Mage::helper('netsuite')->__('History ID'),
            'align' => 'left',
            'width' => $evenWidthCell,
            'filter' => false,
            'index' => 'history_id',
        ));

        $this->addColumn('entity_type', array(
            'header' => Mage::helper('netsuite')->__('Entity Type'),
            'align' => $evenWidthCell,
            'filter' => false,
            'index' => 'entity_type',
        ));

        $this->addColumn('netsuite_id', array(
            'header' => Mage::helper('netsuite')->__('Netsuite Id'),
            'align' => $evenWidthCell,
            'filter' => false,
            'index' => 'netsuite_id',
        ));

        $this->addColumn('magento_id', array(
            'header' => Mage::helper('netsuite')->__('Magento Id'),
            'align' => $evenWidthCell,
            'filter' => false,
            'index' => 'magento_id',
        ));

        $this->addColumn('sync_direction', array(
            'header' => Mage::helper('netsuite')->__('Direction'),
            'align' => $evenWidthCell,
            'filter' => false,
            'index' => 'sync_direction',
        ));
        $this->addColumn('sync_datetime', array(
            'header' => Mage::helper('netsuite')->__('Date Time'),
            'align' => $evenWidthCell,
            'filter' => false,
            'index' => 'sync_datetime',
        ));

        $this->addColumn('action', array(
            'header' => Mage::helper('netsuite')->__('Action'),
            'width' => '100',
            'type' => 'action',
            'getter' => 'getId',
            'actions' => array(
                array(
                    'caption' => Mage::helper('netsuite')->__('delete'),
                    'url' => array('base' => '*/*/delete'), // get the current controller delete action url
                    'field' => 'id'
                )
            ),
            'filter' => false,
            'sortable' => false,
            'index' => 'stores',
            'is_system' => true,
        ));
    }

    /**
     * Returns the edit url for a given table row
     *
     * @param string $row
     * @return string
     */
    public function getRowUrl($row)
    {
        return $this->getUrl('*/*/edit', array('id' => $row->getId()));
    }

    protected function _prepareMassaction()
    {

        $this->setMassactionIdField('history_id');
        $this->getMassactionBlock()->setFormFieldName('history');

        $this->getMassactionBlock()->addItem('delete', array(
            'label' => Mage::helper('netsuite')->__('Delete'),
            'url' => $this->getUrl('*/*/massDelete'), // get the current controller mass delete action url
            'confirm' => Mage::helper('netsuite')->__('Are you sure?')
        ));
        return $this;
    }

}