<?php

?>
<?php

/**
 * This class builds the table of queued jobs
 *  
 */
class CloudCoders_NetSuite_Block_Adminhtml_Queuejob_Grid extends Mage_Adminhtml_Block_Widget_Grid
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('queueGrid');
        $this->setDefaultSort('job_id');
        $this->setDefaultDir('ASC');
        $this->setEmptyText('No queued jobs');
        $this->setSaveParametersInSession(true);
        $this->setVarNameFilter('queue_filter');
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('netsuite/simpleproduct')->getCollection();    
        $this->setCollection($collection);

        parent::_prepareCollection();
        return $this;
    }

    protected function _prepareColumns()
    {
        $evenWidthCell = '60px'; // Magento will try to distribute the cells evenly

        $this->addColumn('job_id', array(
            'header' => Mage::helper('netsuite')->__('Job ID'),
            'align' => 'left',
            'width' => $evenWidthCell,
            'filter' => false,
            'index' => 'job_id',
        ));
        $this->addColumn('item_netsuite_id', array(
            'header' => Mage::helper('netsuite')->__('Netsuite Id'),
            'align' => 'left',
            'width' => $evenWidthCell,
            'filter' => false,
            'index' => 'job_item',
            'renderer' =>'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Queuejob_NetsuiteId'
        ));
         $this->addColumn('name', array(
            'header' => Mage::helper('netsuite')->__('Name'),
            'align' => 'left',
            'filter' => false,
            'index' => 'job_item',
            'renderer' =>'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Queuejob_Name'
        ));

        $this->addColumn('time', array(
            'header' => Mage::helper('netsuite')->__('Queued Time Stamp'),
            'align' => 'left',
            'filter' => false,
            'index' =>  'job_item',
            'renderer' =>'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Queuejob_JobAddedTime'
        ));

        $this->addColumn('status', array(
            'header' => Mage::helper('netsuite')->__('Job Status'),
            'align' => 'left',
            'filter' => false,
            'index' => 'job_status',
            'renderer' =>'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Queuejob_Status'
        ));
        $this->addColumn('endpoint', array(
            'header' => Mage::helper('netsuite')->__('End Point'),
            'align' => 'left',
            'filter' => false,
            'index' => 'job_item',
            'renderer' =>'CloudCoders_NetSuite_Block_Adminhtml_Renderer_Queuejob_Endpoint'
        ));
        parent::_prepareColumns();
    }

    protected function _prepareMassaction()
    {
        return $this;
    }

    /**
     * Hide the filter and search button
     * @return boolean
     */
    public function getMainButtonsHtml()
    {
        return false;
    }

}