<?php

?>
<?php

/**
 * Full list of file type sent from netsuite to magento
 *
 */
class CloudCoders_Netsuite_Helper_NetsuiteFileType extends Mage_Core_Helper_Abstract
{

    private $fileTypes = array(
        // Images type
        'BMPIMAGE' => array(
            'name' => 'BMP Image',
            'extension' => '.bmp',
            'contentType' => 'image/x-xbitmap',
        ),
        'GIFIMAGE' => array(
            'name' => 'GIF Image',
            'extension' => '.gif',
            'contentType' => 'image/gif',
        ),
        'ICON' => array(
            'name' => 'Icon Image',
            'extension' => '.ico',
            'contentType' => 'image/ico',
        ),
        'JPGIMAGE' => array(
            'name' => 'JPEG Image',
            'extension' => '.jpg',
            'contentType' => 'image/jpeg',
        ),
        'PNGIMAGE' => array(
            'name' => 'PNG Image',
            'extension' => '.png',
            'contentType' => 'image/x-png',
        ),
        'TIFFIMAGE' => array(
            'name' => 'TIFF Image',
            'extension' => '.tiff',
            'contentType' => 'image/tiff',
        ),
        'PJPGIMAGE' => array(
            'name' => 'PJPEG Image',
            'extension' => '.jpg', //.pjpeg can't be handle by magento
            'contentType' => 'image/pjpeg',
        ),
    );

    /**
     * Returns the extension for the specified file type
     *
     * @param string $type
     * @return mix [string = extension | false = no extension]
     */
    public function getExtension($type)
    {

        $typeArray = (array_key_exists($type, $this->fileTypes)) ? $this->fileTypes[$type] : array();

        if ($typeArray) {
            return $typeArray['extension'];
        }
        return false;
    }

}