<?php

?>
<?php

/**
 * Customer REST API actions
 */
class CloudCoders_NetSuite_Model_Api2_Customer_Rest_Admin_V1 extends CloudCoders_NetSuite_Model_Api2_Customer
{

    /**
     * Adds a new customer
     *
     * @param array $customerData
     * @return string
     */
    public function _create($customerData)
    {
        if (isset($customerData['customer_data'])) {
            $data = $customerData['customer_data'];
            $data['end_point'] = 'customer';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('POST', $data);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * Updates an existing customer
     *
     * @param array $customerData
     * @return string
     */
    public function _update($customerData)
    {
        if (isset($customerData['customer_data'])) {
            $data = $customerData['customer_data'];
            $data['end_point'] = 'customer';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('POST', $data);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * deletes an existing customer
     *
     * @return string
     */
    public function _delete()
    {
        $customerData = $this->getRequest()->getParams();

        if (isset($customerData)) {
            $customerData['end_point'] = 'customer';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('DELETE', $customerData);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * deletes multiple customers
     *
     * @return string
     */
    public function _multiDelete()
    {
        return $this->_delete();
    }

}