<?php

?>
<?php

/**
 * Rest API endpoint for netsuite item to magento simple product
 *
 */
class CloudCoders_NetSuite_Model_Api2_Pmodel_Rest_Admin_V1 extends CloudCoders_NetSuite_Model_Api2_Pmodel
{

    /**
     * Handle the PUT action
     *
     * @param array $productData data from Netsuite
     *
     * @return string
     */
    public function _create($productData)
    {
        if (isset($productData['item_data'])) {
            $data = json_decode($productData['item_data'], true);
            $data['end_point'] = 'product';
            $SimpleProductQueue = Mage::getModel('netsuite/queue');
            if (isset($data['request_action'])) {
                $message = $SimpleProductQueue->addJobFromNetsuite($data['request_action'], $data);
            } else {
                $message = $SimpleProductQueue->addJobFromNetsuite('POST', $data);
            }
            $this->getResponse()->addMessage($message, 200);
            return '/'; // Prevents magento REST API from sending 403 header
        }
    }

    /**
     * Handle the POST action
     *
     * @param array $productData data from Netsuite
     * @return string
     */
    public function _update($productData)
    {
        if (isset($productData['item_data'])) {
            $data = json_decode($productData['item_data'], true);
            $data['end_point'] = 'product';
            $SimpleProductQueue = Mage::getModel('netsuite/queue');
            if (isset($data['request_action'])) {
                $message = $SimpleProductQueue->addJobFromNetsuite($data['request_action'], $data);
            } else {
                $message = $SimpleProductQueue->addJobFromNetsuite('POST', $data);
            }

            $this->getResponse()->addMessage($message, 200);
            return '/'; // Prevents magento REST API from sending 403 header
        }
    }

    /**
     * Handle the DELETE action
     *
     * @return string
     */
    public function _delete()
    {
        $productData = $this->getRequest()->getParams();
        file_put_contents('var/log/delete.txt', print_r($productData));
        if (isset($productData)) {
            $productData['end_point'] = 'product';
            $SimpleProductQueue = Mage::getModel('netsuite/queue');
            $message = $SimpleProductQueue->addJobFromNetsuite('DELETE', $productData);
            $this->getResponse()->addMessage($message, 200);
            return '/'; // Prevents magento REST API from sending 403 header
        }
    }

    /**
     * Handle the DELETE action
     *
     * This method is used when multiple
     * products are to be deleted
     * 
     * @return type
     */
    public function _multiDelete()
    {
        return $this->_delete();
    }

}