<?php

?>
<?php

/**
 * Product price update Rest API
 *
 */
class CloudCoders_NetSuite_Model_Api2_PriceUpdate_Rest_Admin_V1 extends CloudCoders_NetSuite_Model_Api2_PriceUpdate
{

    public function _create($postData)
    {
        $priceData = (isset($postData['price_data'])) ? $postData['price_data'] : array();
       return $this->doUpdate($priceData);
    }

    public function _update($postData)
    {
        $priceData = (isset($postData['price_data'])) ? $postData['price_data'] : array();
       return $this->doUpdate($priceData);
    }

    public function _delete()
    {
        $this->getResponse()->addMessage('', 200);
        return '/';
    }

    public function _multiDelete()
    {
        return $this->_delete();
    }

    /**
     * 
     * @param int $productData
     * @return mix [false | Magento product object ]
     */
    private function getProduct($productData)
    {
        Mage::app()->getStore()->setId(Mage_Core_Model_App::ADMIN_STORE_ID);
        $Product = Mage::getModel('catalog/product')->load($productData['magento_id']);
        return $Product;
    }

    /**
     * update product price information
     * 
     * @param array $priceData
     * @return string
     */
    public function doUpdate($priceData)
    {
        if (isset($priceData['magento_id'])) {
            $Product = $this->getProduct($priceData);
            if ($Product) {
                $price = (isset($priceData['price'])) ? $priceData['price'] : 0.0;
                $msrp = (isset($priceData['msrp'])) ? $priceData['msrp'] : 0;
                $specialPrice = (isset($priceData['special_price'])) ? $priceData['special_price'] : 0;
                $specialFromDate = (isset($priceData['special_from_date'])) ? $priceData['special_from_date'] : '';
                $specialToDate = (isset($priceData['special_to_date'])) ? $priceData['special_to_date'] : '';
                $groupPrice = (isset($priceData['group_price'])) ? $priceData['group_price'] : array();
                $tierPrice = (isset($priceData['tier_price'])) ? $priceData['tier_price'] : array();
                $length = (isset($priceData['length'])) ? $priceData['length'] : 0;
                $width = (isset($priceData['width'])) ? $priceData['width'] : '';
                $height = (isset($priceData['height'])) ? $priceData['height'] : '';

                // Set data
                $Product->setPrice($price);
                $Product->setData('msrp', $msrp);
                $Product->setData('special_price', $specialPrice);
                $Product->setData('special_from_date', $specialFromDate);
                $Product->setData('speical_to_date', $specialToDate);
                $Product->setData('group_price', $groupPrice);             
                $Product->setData(Mage_Catalog_Model_Product_Attribute_Tierprice_Api_V2::ATTRIBUTE_CODE, $tierPrice);
                $Product->setData('length', $length);
                $Product->setData('width', $width);
                $Product->setData('height', $height);
                $Product->save();
            }
        }
        $this->getResponse()->addMessage('Product price was successfully updated', 200);
        return '/';
    }

}