<?php

?>
<?php

/**
 * Salesorder REST API actions
 */
class CloudCoders_NetSuite_Model_Api2_SalesOrder_Rest_Admin_V1 extends CloudCoders_NetSuite_Model_Api2_SalesOrder
{

    /**
     * Updates an existing sales order
     *
     * @param array $salesOrderData
     * @return string
     */
    public function _create($salesOrderData)
    {
        if (isset($salesOrderData['order_data'])) {
            $data = $salesOrderData['order_data'];
            $data['end_point'] = 'salesorder';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('POST', $data);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * Updates an existing sales order
     *
     * @param array $salesOrderData
     * @return string
     */
    public function _update($salesOrderData)
    {
        if (isset($salesOrderData['order_data'])) {
            $data = $salesOrderData['order_data'];
            $data['end_point'] = 'salesorder';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('POST', $data);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * Deletes/Cancel a sales order
     * 
     * This function is not fully implemented as of yet
     *
     * @return string
     */
    public function _delete()
    {
        $salesOrderData = $this->getRequest()->getParams();

        if (isset($salesOrderData)) {
            $salesOrderData['end_point'] = 'salesorder';
            $CustomerQueue = Mage::getModel('netsuite/queue');
            $message = $CustomerQueue->addJobFromNetsuite('DELETE', $salesOrderData);
            $this->getResponse()->addMessage($message, 200);
            return '/';
        }
    }

    /**
     * deletes multiple salesorder
     *
     * @return string
     */
    public function _multiDelete()
    {
        return $this->_delete();
    }

}