<?php

?>
<?php

/**
 * Product stock level update REST api
 */
class CloudCoders_NetSuite_Model_Api2_StockLevel_Rest_Admin_V1 extends CloudCoders_NetSuite_Model_Api2_StockLevel
{

    public function _create($postData)
    {
       return $this->doStockUpdate($postData);
    }

    public function _update($postData)
    {
        return $this->doStockUpdate($postData);
    }

    public function _delete()
    {
        $this->getResponse()->addMessage('', 200);
        return '/';
    }

    public function _multiUpdate($postkData)
    {
        $this->getResponse()->addMessage('', 200);
        return '/';
    }

    public function _multiDelete()
    {
        return $this->_delete();
    }

    /**
     * 
     * @param type $postData
     * @return string
     */
    private function doStockUpdate($postData)
    {
        $stockData = isset($postData['stock_data']) ? $postData['stock_data'] : array();
        
        $this->getResponse()->addMessage('stock updated successfully', 200);
        if (isset($stockData['magento_id'])) {
            $Product = $this->getProduct($stockData);
            if ($Product) {
                $StockData = Mage::getModel('cataloginventory/stock_item')->loadByProduct($Product->getId());
                if ($StockData->getData()) {
                    // For an existing product update the stock
                    $qty = (isset($stockData['stock_data']['qty'])) ? $stockData['stock_data']['qty'] : 0;
                    $StockData->setData('qty', $qty);
                    $setIsInStock = (isset($stockData['stock_data']['is_in_stock'])) ? true : false;
                    if ($setIsInStock) {
                        if ($qty >= $StockData->getMinSaleQty()) {
                            $StockData->setData('is_in_stock', 1);
                        } else {
                            $StockData->setData('is_in_stock', 0);
                        }
                    }

                    $StockData->setData('manage_stock', 1);
                    $StockData->setData('use_config_manage_stock', 1);
                    $StockData->save();
                    $Product->save();
                }
            }
        }
         $this->getResponse()->addMessage('Product stock level was successfully updated', 200);
        return '/';
    }

    private function getProduct($stockData)
    {
        Mage::app()->getStore()->setId(Mage_Core_Model_App::ADMIN_STORE_ID);
        $Product = Mage::getModel('catalog/product')->load($stockData['magento_id']);
        return $Product;
    }

}