<?php

?>
<?php

/**
 * Logs debug and error mesages to a file or current session
 *
 */
class Logger
{

    const DEBUG_TO_SESSION = false,
            DEBUG_TO_LOG = true;

    private $log = '';

    /**
     * Logs a message to the current session or a file
     *
     * @param string $message
     * @return \Logger
     */
    public function log($message)
    {
        if (self::DEBUG_TO_SESSION) {
            return $this->loadToSession($message);
        }

        if (self::DEBUG_TO_LOG) {
            return $this->logTofile($message);
        }
    }

    /**
     * Writes log message to a file
     *
     * @param string $message
     * @return \Logger
     */
    public function logTofile($message)
    {
        Mage::log($message);
        $this->log += "\r\n" . $message;
        return $this;
    }

    /**
     * Logs the specified message to the current session
     *
     * @param string $message
     * @return \Logger
     */
    public function loadToSession($message)
    {
        Mage::getSingleton('core/session')->addNotice($message);
        $this->log += "\r\n" . $message;
        return $this;
    }

    /**
     * Dump current messages to stdout
     */
    public function dumpMesage()
    {
        print_r($this->log);
    }

    /**
     * Returns current log messages as a string
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->log;
    }

}