<?php

?>
<?php

/**
 * Cleanup front controller
 *
 */
class CloudCoders_NetSuite_Adminhtml_CleanupController extends Mage_Adminhtml_Controller_action
{

    protected function _initAction()
    {

        $this->loadLayout()
                ->_setActiveMenu('netsuite/items')
                ->_addBreadcrumb(Mage::helper('netsuite')->__('Items Manager'), Mage::helper('netsuite')->__('Item Manager'));

        return $this;
    }

    public function indexAction()
    {
        $this->_initAction()
                ->renderLayout();
    }

    public function newAction()
    {
        Mage::helper('netsuite/cleanup')->compareList();
        $this->_redirect('*/*/'); // Redirect to this controller index action
    }

    /**
     * Deletes a record from the clean up table
     */
    public function deleteAction()
    {
        if ($this->getRequest()->getParam('id') > 0) {
            try {
                $model = Mage::getModel('netsuite/cleanup');
                $model->load($this->getRequest()->getParam('id'));
                 if(file_exists('media/catalog/product' . $model->getFilename())){
                     @unlink('media/catalog/product' . $model->getFilename());
                 }
                $model->setId($this->getRequest()->getParam('id'))->delete();

                Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('netsuite')->__('Item was successfully deleted'));
                $this->_redirect('*/*/'); // Redirect to this controller index action
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
                $this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id'))); // Redirect to this controller edit action
            }
        }
        $this->_redirect('*/*/'); // Redirect to this controller index action
    }

    /**
     * Deletes multiple records from the clean up table
     */
    public function massDeleteAction()
    {
        $imageIds = $this->getRequest()->getParam('cleanup');
        if (!is_array($imageIds)) {
            Mage::getSingleton('adminhtml/session')->addError(Mage::helper('adminhtml')->__('Please select item(s)'));
        } else {
            try {
                $model = Mage::getModel('netsuite/cleanup');
                foreach ($imageIds as $currentImageId) {
                    $model->load($currentImageId);
                    if(file_exists('media/catalog/product' . $model->getFilename())){
                     @unlink('media/catalog/product' . $model->getFilename());
                    }
                    
                    $model->setId($currentImageId)->delete();
                }
                Mage::getSingleton('adminhtml/session')->addSuccess(
                        Mage::helper('adminhtml')->__(
                                'Total of %d record(s) were successfully deleted', count($imageIds)
                        )
                );
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index'); // Redirect to this controller index action
    }

}