<?php

?>
<?php

/**
 * Description of HistoryController
 *
 * @author Jibao
 */
class CloudCoders_NetSuite_Adminhtml_HistoryController extends Mage_Adminhtml_Controller_action
{

    protected function _initAction()
    {

        $this->loadLayout()
                ->_setActiveMenu('netsuite/history')
                ->_addBreadcrumb(Mage::helper('netsuite')->__('Sync History'), Mage::helper('netsuite')->__('Sync History'));

        return $this;
    }

    public function indexAction()
    {
        $this->_initAction()
                ->renderLayout();
    }

    /**
     * Suppose to be use for creating new history record
     *
     * Since we are not creating history record from the backend
     * the browser is redirected to the moduel index page
     */
    public function newAction()
    {
        $this->_redirect('*/*/'); // Redirects to the current module index page
    }

    public function editAction()
    {
        $this->_title($this->__('Sync History'))
                ->_title($this->__('Sync History'));

        $Model = Mage::getModel('netsuite/history');
        $historyId = $this->getRequest()->getParam('id');
        if ($historyId) {
            $breadCrumb = Mage::helper('netsuite')->__('View History');
            $Model->load($historyId);
        } else {
            $this->_title(Mage::helper('netsuite')->__('View History'));
            $breadCrumb = Mage::helper('netsuite')->__('View History');
        }

        $this->_initAction()->_addBreadcrumb($breadCrumb, $breadCrumb);

        $data = Mage::getSingleton('adminhtml/session')->getFormData(true);

        if ($data) {
            $Model->addData($data);
        }

        Mage::register('sync_history', $Model);
        $this->_addContent($this->getLayout()->createBlock('netsuite/adminhtml_history_edit'))
                ->_addLeft($this->getLayout()->createBlock('netsuite/adminhtml_history_edit_tabs'));

        $this->renderLayout();
    }

    public function deleteAction()
    {
        $historyId = $this->getRequest()->getParam('id');

        if ($historyId) {
            $Model = Mage::getModel('netsuite/history');
            $Model->load($historyId);

            if (!$Model->getId()) {
                $this->_getSession()->addError(Mage::helper('netsuite')->__('Could not delete history'));
            }

            $Model->delete();
            $this->_redirect('*/*/'); // Redirect to referer page
        }
    }

    public function massDeleteAction()
    {
        $histories = $this->getRequest()->getParam('history');

        if (!is_array($histories)) {
            Mage::getSingleton('adminhtml/session')->addError($this->__('Please select item(s)'));
        } else {
            try {
                foreach ($histories as $curHistory) {
                    $Reseller = Mage::getSingleton('netsuite/history')
                            ->load($curHistory);
                    $Reseller->delete();
                }
                $this->_getSession()->addSuccess(
                        $this->__('Total of %d record(s) were successfully updated', count($histories))
                );
            } catch (Exception $e) {
                $this->_getSession()->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index');
    }

}