<?php

?>
<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

/**
 * Debug controller
 *
 * This controller is use to debug the entire module
 * Please refer to the documentatin on confluence
 *
 * @example https://system.cloudcoders.com.au/confluence/display/EP/Magento+Module+Debug documentation
 *
 */
class CloudCoders_NetSuite_DebugController extends Mage_Core_Controller_front_Action
{

    public function indexAction()
    {
        print "<pre>";
        print "Netsuite Model Dev Mode";
    }

    public function orderAction()
    {
        print('sending order<br/>');
        $orderId = $this->getRequest()->getParam('id');
        $displayJson = $this->getRequest()->getParam('display');
        if (!$orderId) {
            $orderId = 1;
        }
        $Order = Mage::helper('netsuite/sender');
        $result = $Order->sendOrderToNetsuite($orderId, $displayJson);

        print('<pre>');
        print_r($result) . '<br/>';
        print ($result) ? "completed successfully" : "something went wrong";
        print("<br/>done");
    }

    public function customerAction()
    {
        $customerId = $this->getRequest()->getParam('id');
        if (!$customerId) {
            $customerId = 2;
        }
        $Customer = Mage::helper('netsuite/sender');
        $result = $Customer->sendCustomerToNetsuite($customerId);
        print('<pre>');
        print_r($result) . '<br/>';
        print ($result) ? "completed successfully" : "something went wrong";
        print("<br/>done");
    }

    public function productAction()
    {
        $AicProduct = Mage::getModel('netsuite/queue');
        $result = $AicProduct->processNetsuiteToMagentoQueue();
        $result = (!empty($result)) ? $result : "Nothing queued to process";
        print('<pre>');
        print_r($result);
        print('<br>done');
    }

    public function processAction()
    {
        $Queue = Mage::getModel('netsuite/queue');
        print('<pre>');
        print_r($Queue->process_queue());
    }

    public function methodAction()
    {
        echo 'Payment Methods';
        $allActivePaymentMethods = Mage::getModel('payment/config')->getActiveMethods();
        $allActiveShippingMethods = Mage::getSingleton('shipping/config')->getActiveCarriers();
        print('<pre>');

        foreach ($allActivePaymentMethods as $curMethod) {
            print( $curMethod->getCode() . ' = ' . $curMethod->getTitle() . '<br/><br/>');
        }
        print('</pre>');
        echo "Shipping Methods";
        print('<pre>');
        $methods = $allActiveShippingMethods;
        $shipping = array();
        foreach ($methods as $_ccode => $_carrier) {

            if ($_methods = $_carrier->getAllowedMethods()) {
                if (!$_title = Mage::getStoreConfig("carriers/$_ccode/title"))
                    $_title = $_ccode;
                foreach ($_methods as $_mcode => $_method) {
                    $_code = $_ccode . '_' . $_mcode;
                    $shipping[$_ccode][$_code] = array('title' => $_method, 'carrier' => $_title);
                }
            }
        }
        echo "\n";
        print_r($shipping);
        print('done');
    }

    public function inventoryAction()
    {
        $Updater = Mage::getModel('netsuite/inventoryUpdater');
        print('<pre>');
        $Updater->updateInventory();
        print "Inventory update done";
    }

    public function wsAction()
    {

        $name = dirname(dirname(__FILE__)) . '/Model/Custom/Ws/NetSuiteService.php';
        require_once $name;

        $Uom = new UnitsTypeSearchBasic();
        $isInActveFilter = new SearchBooleanField();
        $isInActveFilter->searchValue = false;
        $Uom->isInActive = $isInActveFilter;

        $Request = new SearchRequest();
        $Request->searchRecord = $Uom;

        $service = new NetSuiteService();
        $service->setSearchPreferences(false);
        $Result = $service->search($Request);



        if ($Result->searchResult->status->isSuccess) {
            print_r($Result);
            echo "<H2>Parse</H2>";
            echo '<pre>';
            foreach ($Result->searchResult->recordList->record as $currentUnit) {
                echo "name: {$currentUnit->name}<br/>";
                echo "id: {$currentUnit->internalId}<br/>";
                echo 'units:<br/>';
                foreach ($currentUnit->uomList->uom as $currentUom) {
                    echo "\t name: {$currentUom->unitName} <br/>";
                    echo "\t id: {$currentUom->internalId} <br/>";
                    echo "\t plural name: {$currentUom->pluralName} <br/>";
                    echo "\t is base unit: {$currentUom->baseUnit} <br/>";
                    echo "\t coversion Rate: {$currentUom->coversionRate}<br/>";
                    echo "\t .....................<br/>";
                }

                echo "<br/>";
                echo "-------<br/>";
            }
        } else {
            print_r($Request);
            echo "Failed";
        }

        return;
        $params = new GetDataCenterUrlsRequest();
        $params->account = 'TSTDRV505745';

        $service = new NetSuiteService();
        $response = $service->getDataCenterUrls($params);
        print_r($response->getDataCenterUrlsResult->dataCenterUrls->webservicesDomain);
    }

}